#include <stdlib.h>
#include <stdio.h>
#include <stdbool.h>
#include <unistd.h>
#include <math.h>

#include <SDL.h>
#include <SDL_ttf.h>
#include <SDL_image.h>

#include "slime.h"
#include "jeu.h"
#include "objet.h"
#include "menu.h"

Uint32 temps_act = 0;

/*
This file is part of Slime Volley.

	Slime Volley is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	Slime Volley is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Slime Volley.  If not, see <http://www.gnu.org/licenses/>.

Copyright (c) MCMic, VinDuv.

$Id: slime.c 59 2008-01-12 11:58:31Z mcmic $
*/


/* banque de données générale pour le jeu */
struct SoundBank sndbank;


void jeu() {
	SDL_Event evenement;
	
	//constantes impossible dans un switch, nécessité de remplacer le sous switch par du if else if.

	bool continuer = true;
	bool touche_gauche = false, touche_droite = false;
	bool touche_Q = false, touche_D = false;


	// Gestion du temps et du score (affichage de texte)
	Uint32 temps_prec, ecart;
	Uint32 temps_fps;
	Uint8 cpt;
	char fps_chaine[10] = "\0";
	char score_chaine[15] = "\0";
	SDL_Surface *fps_aff, *score_aff;
	SDL_Color coul_fps = {0x00, 0x00, 0x00};
	SDL_Rect pos_fps = {0, 0, 0, 0};
	SDL_Rect pos_score;
	pos_score.x = 350;
	pos_score.y = 200;

	// Filet
	SDL_Surface *filet;
	SDL_Rect filet_pos = { FILET_GAUCHE , HAUT_ECRAN - HAUT_SOL - FILET_HAUT };
	filet = SDL_CreateRGBSurface(SDL_HWSURFACE, FILET_DROITE-FILET_GAUCHE, FILET_HAUT, 32, 0, 0, 0, 0);
	SDL_FillRect(filet, NULL, SDL_MapRGB(filet->format, 255, 255, 255));

	// Objets et joueurs
	slime_obj *balle, *joueur_1, *oeil_j1, *joueur_2, *oeil_j2;
	int JG = 0,JD = 0;
	char imageJG[] = "slimeJG1.png", imageJD[] = "slimeJD1.png";
	int temps_chg = SDL_GetTicks();
	int jscore1 = 0,jscore2 = 0;
	bool vainq = 0;
	
	// Sol
	SDL_Surface *sol;
	SDL_Rect sol_pos = {0, HAUT_ECRAN - HAUT_SOL, 0, 0};
	sol = SDL_CreateRGBSurface(SDL_HWSURFACE, LARG_ECRAN, HAUT_SOL, 32, 0, 0, 0, 0);
	SDL_FillRect(sol, NULL, SDL_MapRGB(sol->format, 0, 255, 0));

	while(!quitter) {
	touche_gauche = false; touche_droite = false;
	touche_Q = false; touche_D = false;
	continuer = true;
	temps_fps = 0;cpt = 0;
	balle = cree_objet(92, LARG_ECRAN / 2, LARG_ECRAN, HAUT_ECRAN - HAUT_SOL, true, IMG_Load("balle.png"));
	joueur_1 = cree_objet(50, -1, 400, HAUT_ECRAN - HAUT_SOL, true, IMG_Load(imageJG) );
	oeil_j1 = cree_objet(0, 0, 400, HAUT_ECRAN - HAUT_SOL, true, IMG_Load("oeil.png"));
	joueur_2 = cree_objet(LARG_ECRAN - 150, -1, LARG_ECRAN, HAUT_ECRAN - HAUT_SOL, true, IMG_Load(imageJD));
	oeil_j2 = cree_objet(0, 0, 400, HAUT_ECRAN - HAUT_SOL, true, IMG_Load("oeil.png"));
	balle->x = (vainq ? LARG_ECRAN - 108 : 92);
	temps_prec = SDL_GetTicks();
	
	while(continuer && !quitter) {
		temps_act = SDL_GetTicks();
		ecart = temps_act - temps_prec;
		SDL_PollEvent(&evenement);
		switch(evenement.type) {
			case SDL_QUIT:
				continuer = false;
				quitter = true;
			break;
			case SDL_KEYDOWN:
				if(evenement.key.keysym.sym == touches_jg->haut) {
						if(joueur_1->y == joueur_1->lim_bas) { // Le joueur 2 est en bas
							joueur_1->vy = -300;
							if(touche_droite) {
								joueur_1->vx = 150;
							} else if(touche_gauche) {
								joueur_1->vx = -150;
							} else {
								joueur_1->vx = 0;
							}
						}
					} else if(evenement.key.keysym.sym == touches_jg->bas) { // Flèche bas
						if(SDL_GetTicks() - temps_chg > 500) {
							JG++;
							sprintf(imageJG,"slimeJG%d.png",JG+1);
							if(IMG_Load(imageJG) == NULL) {
								JG = 0;
								sprintf(imageJG,"slimeJG%d.png",JG+1);
							}
							joueur_1->forme = IMG_Load(imageJG);
							temps_chg = SDL_GetTicks();
						}
					} else if(evenement.key.keysym.sym == touches_jg->droite) { // Flèche droite
						touche_droite = true;
					} else if(evenement.key.keysym.sym == touches_jg->gauche) { // Flèche gauche
						touche_gauche = true;
					} else if(evenement.key.keysym.sym == SDLK_ESCAPE) { // Echap
						quitter = true;
						continuer = !quitter;
						
					} else if(evenement.key.keysym.sym == touches_jd->haut) { // Touche Z
						if(joueur_2->y == joueur_2->lim_bas) { // Le joueur 2 est en bas
							joueur_2->vy = -300;
							if(touche_D) {
								joueur_2->vx = 150;
							} else if(touche_Q) {
								joueur_2->vx = -150;
							} else {
								joueur_2->vx = 0;
							}
						}
					} else if(evenement.key.keysym.sym == touches_jd->bas) { // Touche S
						if(SDL_GetTicks() - temps_chg > 500) {
							JD++;
							sprintf(imageJD,"slimeJD%d.png",JD+1);
							if(IMG_Load(imageJD) == NULL) {
								JD = 0;
								sprintf(imageJD,"slimeJD%d.png",JD+1);
							}
							joueur_2->forme = IMG_Load(imageJD);
							temps_chg = SDL_GetTicks();
						}
					} else if(evenement.key.keysym.sym == touches_jd->droite) { // Touche D
						touche_D = true;
					} else if(evenement.key.keysym.sym == touches_jd->gauche) { // Touche Q
						touche_Q = true;
					}
			break;
			case SDL_KEYUP:
				if(evenement.key.keysym.sym == touches_jg->droite)	{			// Flèche droite
					touche_droite = false;
				} else if(evenement.key.keysym.sym == touches_jg->gauche) { // Flèche gauche
						touche_gauche = false;
				} else if(evenement.key.keysym.sym == touches_jd->droite) { // Flèche droite
						touche_D = false;
				} else if(evenement.key.keysym.sym == touches_jd->gauche) { // Flèche gauche
						touche_Q = false;
   		   }
			break;
			default:
			break;
		}
		
		if(joueur_1->y == joueur_1->lim_bas) { // Le joueur 1 est en bas
			if(touche_droite) {
				joueur_1->x += 0.15 * ecart;
			} else if(touche_gauche) {
				joueur_1->x -= 0.15 * ecart;
			} else {
				joueur_1->vx = 0;
			}
		}

		if(joueur_2->y == joueur_2->lim_bas) { // Le joueur 2 est en bas
			if(touche_D) {
				joueur_2->x += 0.15 * ecart;
			} else if(touche_Q) {
				joueur_2->x -= 0.15 * ecart;
			} else {
				joueur_2->vx = 0;
			}
		}
		
		// Collisions entre balle et mur...
		bool collision = false;
		bool collision_filet = false;

		if(balle->y + 16 > HAUT_ECRAN - HAUT_SOL - FILET_HAUT) {
			if(balle->x + 16 <= FILET_GAUCHE && x_suiv(balle, ecart) + 16 > FILET_GAUCHE) {
				deplace(balle, ecart);
				balle->vx = -balle->vx;
				balle->x = FILET_GAUCHE - 16;
				collision = true;
				collision_filet = true;
				fflush(stdout);
			
			} else if(balle->x >= FILET_DROITE && x_suiv(balle, ecart) < FILET_DROITE) {
				deplace(balle, ecart);
				balle->vx = -balle->vx;
				balle->x = FILET_DROITE;
				collision = true;
				collision_filet = true;
				
			} else if(balle->x + 16 > FILET_GAUCHE && balle->x < FILET_DROITE) {
				deplace(balle, ecart);
				balle->vy = -abs(balle->vy);
				collision = true;
				collision_filet = true;
			}
		}
		
		if(!collision) {
			deplace(balle, ecart);
		}
		
		if( collision_filet)
			PlaySound( sndbank.collision_balle_filet, 0);
			
		// Et entre balle et slimes...
		Sint16 dist_j_x, dist_j_y;
		float dist_j;
		dist_j_x = balle->x - joueur_1->x - 42;
		dist_j_y = balle->y - joueur_1->y - 42;
		dist_j = sqrt(dist_j_x * dist_j_x + dist_j_y * dist_j_y);
		if(dist_j <= 58 && balle->y < joueur_1->y + 50) {
			balle->vx = dist_j_x * 500.0 / dist_j;
			balle->vy = dist_j_y * 500.0 / dist_j;
			balle->x = joueur_1->x + 42 + dist_j_x * 58 / dist_j;
			balle->y = joueur_1->y + 42 + dist_j_y * 58 / dist_j;

			/* play sound */
			PlaySound( sndbank.collision_balle_slime, 0);
		}

		dist_j_x = balle->x - joueur_2->x - 42;
		dist_j_y = balle->y - joueur_2->y - 42;
		dist_j = sqrt(dist_j_x * dist_j_x + dist_j_y * dist_j_y);
		if(dist_j <= 58 && balle->y < joueur_2->y + 50) {
			balle->vx = dist_j_x * 500.0 / dist_j;
			balle->vy = dist_j_y * 500.0 / dist_j;
			balle->x = joueur_2->x + 42 + dist_j_x * 58 / dist_j;
			balle->y = joueur_2->y + 42 + dist_j_y * 58 / dist_j;
			
			/* play sound */
			PlaySound( sndbank.collision_balle_slime, 0);
		}		

		deplace(joueur_1, ecart);
		deplace(joueur_2, ecart);

		// On vérifie que le joueur 1 ne sort pas du terrain.
		if(joueur_1->x <= 0) {
			joueur_1->x = 0;
			joueur_1->vx = 0;
		} else if(joueur_1->x >= joueur_1->lim_droite) {
			joueur_1->x = joueur_1->lim_droite;
			joueur_1->vx = 0;
		}
		
		if(joueur_1->y >= joueur_1->lim_bas) {
			joueur_1->y = joueur_1->lim_bas;
			joueur_1->vx = 0;
			joueur_1->vy = 0;
		}

		// Même chose pour le joueur 2.
		if(joueur_2->x <= 406) {
			joueur_2->x = 406;
			joueur_2->vx = 0;
		} else if(joueur_2->x >= joueur_2->lim_droite) {
			joueur_2->x = joueur_2->lim_droite;
			joueur_2->vx = 0;
		}
		
		if(joueur_2->y >= joueur_1->lim_bas) {
			joueur_2->y = joueur_1->lim_bas;
			joueur_2->vx = 0;			
			joueur_2->vy = 0;
		}	

		// On replace les yeux...
		Sint16 dist_oeil_x, dist_oeil_y;
		float dist_oeil;
		dist_oeil_x = joueur_1->x + 69 - (balle->x + 8);
		dist_oeil_y = joueur_1->y + 24 - (balle->y + 8);
		dist_oeil = sqrt(dist_oeil_x * dist_oeil_x + dist_oeil_y * dist_oeil_y);
		oeil_j1->x = joueur_1->x + 69 - 5 - 4 * dist_oeil_x/dist_oeil;
		oeil_j1->y = joueur_1->y + 24 - 5 - 4 * dist_oeil_y/dist_oeil;

		dist_oeil_x = joueur_2->x + 31 - (balle->x + 8);
		dist_oeil_y = joueur_2->y + 24 - (balle->y + 8);
		dist_oeil = sqrt(dist_oeil_x * dist_oeil_x + dist_oeil_y * dist_oeil_y);
		oeil_j2->x = joueur_2->x + 31 - 5 - 4 * dist_oeil_x/dist_oeil;
		oeil_j2->y = joueur_2->y + 24 - 5 - 4 * dist_oeil_y/dist_oeil;		

		// Et pour la balle->..
		if(balle->x <= 0) {
			balle->x = 0;
			balle->vx = abs(balle->vx);
		} else if(balle->x >= balle->lim_droite) {
			balle->x = balle->lim_droite;
			balle->vx = -abs(balle->vx);
		}
		
		if(balle->y >= balle->lim_bas) {		//fin du set?
			balle->y = balle->lim_bas;
			balle->vy = -balle->vy;
			continuer = false;
			if(balle->x > 403) {
			printf("joueur 1 gagne!\n");
			jscore1 ++;vainq = 0;
			} else {
			printf("joueur 2 gagne!\n");
			jscore2 ++;vainq = 1;
			}
		}
		
		SDL_FillRect(ecran, NULL, SDL_MapRGB(ecran->format, 0, 0, 255));
		
		dessine(joueur_1, ecran);
		dessine(oeil_j1, ecran);
		dessine(joueur_2, ecran);
		dessine(oeil_j2, ecran);
		dessine(balle, ecran);
		SDL_BlitSurface(sol, NULL, ecran, &sol_pos);
		SDL_BlitSurface(filet, NULL, ecran, &filet_pos);
		fps_aff = TTF_RenderText_Solid(police, fps_chaine, coul_fps);
		SDL_BlitSurface(fps_aff, NULL, ecran, &pos_fps);
		
		SDL_Flip(ecran);

		if(SDL_GetTicks() - temps_prec < (2000/MAX_FPS)) { // Il faut attendre un peu
			SDL_Delay((2000/MAX_FPS) - (SDL_GetTicks() - temps_prec));
		}
		temps_prec = temps_act;
		cpt = cpt + 1;
		
		if((temps_act - temps_fps) >= 1000) {
			sprintf(fps_chaine, "FPS : %d", cpt);
			cpt = 0;
			temps_fps = temps_act;
		}	
	}
	
	sprintf(score_chaine, "Score : %d - %d", jscore1, jscore2);
	score_aff = TTF_RenderText_Solid(police, score_chaine, coul_fps);
	SDL_BlitSurface(score_aff, NULL, ecran, &pos_score);
	SDL_Flip(ecran);
		if (!quitter) SDL_Delay(1000);
			if ((jscore1 > 9) || (jscore2 > 9)) {
			quitter = true;
		}
	}
	
	return;
}
